<?php
/*
 * ==================================================================
 * Plugin GLOSSAIRE_XH for CMSimple_XH
 * ==================================================================
 * Version:    1.0.5 - sep 2016
 * Copyright:  Ludovic AMATHIEU
 * Website:    http://www.f5swn.fr (and contact)
 * License:    GNU GPLv3 - http://www.gnu.org/licenses/gpl-3.0.en.html
 * ==================================================================
 */

if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}
  
if ($lefichier != ""){   //si la liste n'est pas vide
   $txtmod = $c[$s];    // le texte de l'article est placé dans $txtmod pour les recherches/remplacements
   $lignes = array();
   $deffin = "";
   $deffin_arr = array();
   $cptlig = count($lignes2);
   for($b=0; $b<$cptlig; $b++) {       //début boucle lecture de chaque mot
      $lignes[$b] = explode("|",$lignes2[$b]);    // [0|1] [0|1] => [ [0][1] ] [ [0][1] ]
                      
      /* pour utiliser la ligne en cours : $lignes[$b][0] est le numéro
                                       $lignes[$b][1] est le mot  */  
                                       
      /////// recherche et remplacement de la première occurrence du mot //////////////////

      // le mot recherché 
      $lemot = strip_tags($lignes[$b][1]);

      $lemot = stripslashes(trim($lemot));
      
      if ($lemot != ""){   // Cas où $lemot est vide, on ne fait rien 
      
         //le mot recherché par la regex sera seul s'il n'y a pas d'accentuation Iso présente.

         // Pluriels en fonction de la langue. (Les adjectifs ne sont pas prévus)
         $pluriel = (function_exists('pluriel_'.$pl_lng)) ? 'pluriel_'.$pl_lng : 'pluriel_en';
         $lemotabbr = $lemot;
         $lemot = pluriel($lemot, $pluriel);
            
         $count = 0;

         /////////////////Remplacement de la première occurrence du mot, hors balises html, hors liens//////////////////

         // Recherche et remplacement du mot

            if (preg_match("`^[^a-zØ-öø-ÿ]*$`",$lemotabbr)) {  // Si le mot est une abréviation A.B.C. ou ABC (regex case sensitive)

               // ajout variable $lemotabbr_p pour que ABC matche A.B.C. et vice versa
               if (preg_match ("`\.`",$lemotabbr)) { // si des points sont présents
                  $lemotabbr_p = preg_replace("`\.`","",$lemotabbr); // suppression des points
               }
               else { // sinon, ajout de points
                    $chars = preg_split('//', $lemotabbr, -1, PREG_SPLIT_NO_EMPTY);
                    $lemotabbr_p = implode(".", $chars);
                    $lemotabbr_p = preg_replace("`$`", ".", $lemotabbr_p);
               } // Fin traitement abréviation

               $leregex = "`(?!<.*?)(?<![\p{L}_;/-])(".$lemotabbr."|".$lemotabbr_p.")(?=[^\p{L}_/-])(?![^<>]*?>)(?![^>]*?(</.*>)*</(a|h[1-6]))`u";
               $lelien = "<a href=\"#gpop".$lignes[$b][0]."\" class=\"gpop\">$1</a>";
               $txtmod = preg_replace($leregex, $lelien, $txtmod, $plugin_cf['glossaire']['occurrence_number']);
               }
            else { 
              $leregex = "`(?!<.*?)(?<![\p{L}_;/-])(".$lemot.")(?=[^\p{L}_&/-])(?![^<>]*?>)(?![^>]*?(</.*>)*</(a|h[1-6]))`ui";
              $lelien = "<a href=\"#gpop".$lignes[$b][0]."\" class=\"gpop\">$1</a>";
              $txtmod = preg_replace($leregex, $lelien, $txtmod, $plugin_cf['glossaire']['occurrence_number']);
            }
            $lelienreg = "<a href=\"#gpop".$lignes[$b][0]."\" class=\"gpop\">";
            $regcount = "`(".$lelienreg.")`";
            $count = preg_match_all($regcount, $txtmod, $matches);
         //fin mot ou abréviation
      
         $deftit = "";
         $deftxt = "";
         $defconf0 = "";
         $defconf1 = "";
         $largconf = "";
         $defact = "";
         $hdeb = "<div><h4>";
         $hfin = "</h4></div>";
         $figdef = "";

         if ($count != 0) { //Si un remplacement a eu lieu, on charge la définition concernée
            if(file_exists(PATH_GLOSS_DATA.$sl."/def_".$lignes[$b][0].INCEXT)) {
               include(PATH_GLOSS_DATA.$sl."/def_".$lignes[$b][0].INCEXT);
            }
            else {  //Message pour avertir du manque d'un fichier def_xx.inc
                 $avert = $plugin_tx['glossaire']['frontend_msg_def_lost']." ".$lignes[$b][0];
				$o .= XH_message('warning',$avert);
            }

            if ($deftit == ""){  //suppression de la barre titre si le champ titre est vide.
               $hdeb = "<div><h4 class=\"impr\">".$lemotabbr;  //Le mot est utilisé comme titre, seulement à l'impression
               $hfin = "</h4></div>";
            }
            if ($defconf0 == "") {         //sélection option définition élargie
               $largconf = "larg1";
            }
            else {
                 $largconf = "larg2";
            }
            if($defconf1 != ""){$figdef = "<div class=\"figer\" onclick=\"ferm()\"></div>";} 
            else{$figdef = "";}
            $defact = "<div id=\"gpop".$lignes[$b][0]."\" class=\"pp ".$largconf."\">".$figdef.$hdeb.$deftit.$hfin."<div class=\"def\">".$deftxt."</div></div>";     //mise en forme de la def
            $pos = "<div id=\"gpop".$lignes[$b][0];
            if (strpos_arr($deffin_arr, $pos)=== false){ $deffin_arr[$lemotabbr] = $defact; }    //chaque définition est ajoutée dans une variable
         }   //fin chargement définition
      } //fin cas $lemot est vide
    }//fin de boucle
    
    if (!empty($deffin_arr)){ 
       //tri de l'ordre d'affichage des définitions (pour l'impression)
       uksort($deffin_arr, 'wd_unaccent_compare_ci');
       //création de l'affichage des définitions
       foreach($deffin_arr as $def) {
          $deffin .= $def."\n";
       }
       $titpied = $version."<div class=\"impr\" style=\"text-align:center;\"><h3>".$plugin_tx['glossaire']['frontend_print_title']."</h3></div>";
      //titre du glossaire en bas de page, qu'à l'impression
    }
    else {$titpied = $version;}
    if (!empty($deffin)){$txtmod .= $titpied.$deffin; }
    $c[$s] = $txtmod;         //l'article modifié retourne à son traitement initial
} //fin si la liste n'est pas vide
?>