<?php
/*
 * ==================================================================
 * Plugin GLOSSAIRE_XH for CMSimple_XH
 * ==================================================================
 * Version:    1.0.5 - sep 2016
 * Copyright:  Ludovic AMATHIEU
 * Website:    http://www.f5swn.fr (and contact)
 * License:    GNU GPLv3 - http://www.gnu.org/licenses/gpl-3.0.en.html
 * ==================================================================
 */
 

// Prevent direct access and usage from unsupported CMSimple_XH versions.
if (!defined('CMSIMPLE_XH_VERSION')
    || strpos(CMSIMPLE_XH_VERSION, 'CMSimple_XH') !== 0
    || version_compare(CMSIMPLE_XH_VERSION, 'CMSimple_XH 1.6.0', 'lt')
) {
    header('HTTP/1.1 403 Forbidden');
    header('Content-Type: text/plain; charset=UTF-8');
    die(<<<EOT
GLOSSAIRE detected an unsupported CMSimple_XH version.
Uninstall GLOSSAIRE or upgrade to a supported CMSimple_XH version!
EOT
    );
} 
 
$charset = 'utf-8';
define('INCEXT', '.inc');
define('ADMIN_TITLE', $plugin_tx['glossaire']['admin_title']);
define('ADMIN_INTRO', $plugin_tx['glossaire']['admin_intro']);
define('ADMIN_WORDS_AND_DEF_TITLE', $plugin_tx['glossaire']['admin_word_and_def_title']);
define('ADMIN_CONFIGURATION_TITLE', $plugin_tx['glossaire']['admin_configuration_title']);

if (!defined("PATH_GLOSSAIRE")) define("PATH_GLOSSAIRE", $pth['folder']['plugins']."glossaire/");
if (!defined("PATH_GLOSS_CONFIG")) define("PATH_GLOSS_CONFIG", $pth['folder']['plugins']."glossaire/config/");     
if (!defined("PATH_GLOSS_DATA")) define("PATH_GLOSS_DATA", $pth['folder']['plugins']."glossaire/data/");

$versionStr = @file_get_contents($pth['folder']['plugins'].'glossaire/version.nfo');
if ($versionStr != '') {
	$versionArr = explode(',', $versionStr);
	$vresult = $versionArr[2];
}
else $vresult = 'undefined';

define('GLOSS_VERSION', $vresult);
include($pth['folder']['plugins']."glossaire/function_gloss.inc");

// Initialisation du plugin Glossaire 
// (fonction appele depuis template.htm dont le template a t activ depuis la configuration)
function init_Glossaire(){
	global $o, $s, $c, $edit, $sl, $pth, $charset, $plugin_tx, $plugin_cf;
	if (!($edit && XH_ADM) && $s > -1) {
     if(file_exists(PATH_GLOSSAIRE."gloss_inc1".INCEXT)) {
         include(PATH_GLOSSAIRE."gloss_inc1".INCEXT);
         include(PATH_GLOSSAIRE."gloss_inc2".INCEXT);
     }	
	}
}

// dfinition template en cours / template choisi dans select de la configuration
$tpl_choosen =  import('tpl_choosen', 'POST'); // issu du select liste des templates
$tpl_act = import('tpl', 'POST'); // issu de la validation du formulaire
$tpl_value = ($tpl_choosen != '') ? $tpl_choosen : (($tpl_act != '') ? $tpl_act : $cf['site']['template']); 
if ($tpl_act != '') $tpl_choosen = $tpl_act;

// Lecture config, tat du plugin (actif ou dsactiv)
if (is_file (PATH_GLOSS_CONFIG.$tpl_value.INCEXT)){
   include (PATH_GLOSS_CONFIG.$tpl_value.INCEXT);
}
else {
     include (PATH_GLOSS_CONFIG.'config.php');
}
$plugin_state = ($plugin_cf["glossaire"]["plugin_disable_state"] == 'on') ? 'off' : 'on';

if (($plugin_state == 'on') || XH_ADM) {

  if ((file_exists(PATH_GLOSSAIRE."js/gloss.js")) && (file_exists(PATH_GLOSSAIRE."css/gloss_css.php"))) {
     $hjs .= "<script type=\"text/javascript\" src=\"".PATH_GLOSSAIRE."js/gloss.js\"></script>\n";
     if (file_exists(PATH_GLOSSAIRE."js/fonct_util.js")){$hjs .= "<script language=\"javascript\" type=\"text/javascript\" src=\"".PATH_GLOSSAIRE."js/fonct_util.js\"></script>\n";}
     $hjs .= "<link type=\"text/css\" rel=\"stylesheet\" href=\"".PATH_GLOSSAIRE."css/gloss_css.php?tpl=".$tpl_value."\" />\n";
  }
}
?>